<script setup lang="ts">
import { nextTick, onMounted, ref } from 'vue';
import { VForm } from 'vuetify/lib/components/index.mjs';
type User = {
  date: string
  id: number
  firstname: string
  lastname: string
  Salary: number
  status: string
  dialog?: boolean;
  dialogType?: string;
}
const headers = [
  { title: 'Date', key: 'date', value: 'date', },
  { title: 'Id', key: 'id', value: 'id', },
  { title: 'Frist name', key: 'firstname', value: 'firstname' },
  { title: 'Last name', key: 'lastname', value: 'lastname' },
  { title: 'Salary', key: 'salary', value: 'salary' },
  { title: 'Status', key: 'status', value: 'status' },
  { title: 'Pay', key: 'pay', sortable: false },
  { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialog1 = ref(false)
const dialogDelete = ref(false)
const dialogPayAll = ref(false);
const loading = ref(false)
const initialUser: User = {
  date: '',
  id: -1,
  firstname: '',
  lastname: '',
  Salary: 0,
  status: ''
}
const editedUser = ref<User>(JSON.parse(JSON.stringify(initialUser)))
const users = ref<User[]>([])
let editedIndex = -1
let lastId = 13
function onSubmit() {

}

function showDetails(item: User) {
  item.dialog1 = true;
  item.dialogType = 'details';
}
function openPaymentDialog(item: User) {
  item.dialog = true;
  item.dialogType = 'payment';
}


function Confirm(item: User) {
  if (item.status === 'Not Done') {
    item.status = 'Done';
    save();
  }
}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
  })
}
function deleteItemConfirm() {
  users.value.splice(editedIndex, 1)
  closeDelete()
}
function deleteItem(item: User) {
  editedIndex = users.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialogDelete.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return

  if (editedIndex > -1) {
    Object.assign(users.value[editedIndex], editedUser.value)
  } else {
    editedUser.value.id = lastId++
    editedUser.value.status = 'Not Done'
    users.value.push(editedUser.value)
  }

  closeDialog()
}
function payAll() {
  for (const user of users.value) {
    if (user.status === 'Not Done') {
      user.status = 'Done';
    }
  }
  dialogPayAll.value = false;
}
function openPayAllDialog() {
  dialogPayAll.value = true;
}


function initialize() {
  users.value = [{ date: '2024-01-11', id: 1, firstname: 'Test', lastname: ' Naja', Salary: 2000, status: 'Not Done' },
  { date: '2024-01-11', id: 2, firstname: 'Film', lastname: ' Eiei', Salary: 1717, status: 'Not Done' },
  { date: '2024-01-11', id: 3, firstname: 'Wave', lastname: ' Nakub', Salary: 7777, status: 'Not Done' },
  { date: '2024-01-11', id: 4, firstname: 'Tao', lastname: ' Eueu', Salary: 6666, status: 'Not Done' },
  { date: '2024-01-11', id: 5, firstname: 'Peach', lastname: ' Chichi', Salary: 5555, status: 'Not Done' },
  { date: '2024-01-11', id: 6, firstname: 'Kao', lastname: ' nine', Salary: 9999, status: 'Not Done' },
  { date: '2024-01-11', id: 7, firstname: 'Pong', lastname: ' Pang', Salary: 8888, status: 'Not Done' },
  { date: '2024-01-11', id: 8, firstname: 'Boom', lastname: ' Toom', Salary: 3333, status: 'Not Done' },
  { date: '2024-01-11', id: 9, firstname: 'Mew', lastname: ' Mao', Salary: 8080, status: 'Not Done' },
  { date: '2024-01-11', id: 10, firstname: 'Fulkie', lastname: ' eikluf', Salary: 7878, status: 'Not Done' },
  { date: '2024-01-11', id: 11, firstname: 'Test', lastname: ' elel', Salary: 1111, status: 'Not Done' },
  { date: '2024-01-11', id: 12, firstname: 'toto', lastname: ' otot', Salary: 2343, status: 'Not Done' }
  ]
}
onMounted(() => {
  initialize()
})
</script>
<template>
  <div>
    <v-data-table :headers="headers" :items="users" style="background-color: rgba(202, 174, 123, 0.582);">
      <template #item.salary="{ item }">
        <td>{{ item.Salary ? item.Salary : '-' }}</td>
      </template>
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgba(41, 36, 27, 0.623);">
          <v-toolbar-title style="color: white;"><v-icon>mdi-history</v-icon> Salary Payment History </v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->
          <v-btn @click="openPayAllDialog" color="white" variant="outlined" class="mr-3">
            <v-icon>mdi-cash-multiple</v-icon>Pay All
          </v-btn>
          <!-- Pay All Dialog -->
          <v-dialog v-model="dialogPayAll" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to pay all?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" variant="text" @click="dialogPayAll = false">
                  Cancel
                </v-btn>
                <v-btn color="blue darken-1" variant="text" @click="payAll">
                  Confirm
                </v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="white" v-bind="props" variant="outlined">
                <v-icon> mdi-cash</v-icon>
                Add New
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Pay salary</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="3">
                        <v-text-field v-model="editedUser.date" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Date"
                          type="date"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="3">
                        <v-text-field v-model="editedUser.firstname" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Frist name"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="3">
                        <v-text-field v-model="editedUser.lastname" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Last name"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="3">
                        <v-text-field v-model="editedUser.Salary" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Salary"></v-text-field>
                      </v-col>
                      
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">
                  Close
                </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()">
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.pay`]="{ item }">
        <v-btn color="green" dark @click="openPaymentDialog(item)" :disabled="item.status === 'Done'">
          Pay
        </v-btn>
        <v-dialog v-model="item.dialog" max-width="500px">
          <v-card>
            <v-card-title class="text-h5">Confirm Payment</v-card-title>
            <v-card-text>
              Are you sure you want to pay this salary?
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="item.dialog = false">
                Cancel
              </v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="Confirm(item); item.dialog = false">
                Confirm
              </v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="showDetails(item)">
          mdi-eye
        </v-icon>
        <v-icon size="small" @click="deleteItem(item)">
          mdi-delete
        </v-icon>
        <!-- User Details Dialog -->
        <v-dialog v-model="item.dialog1" max-width="500px">
          <v-card>
            <v-card-title class="text-h5">User Details</v-card-title>
            <v-card-text>
              <!-- Display user details here -->
              <div>Date: {{ item.date }}</div>
              <div>ID: {{ item.id }}</div>
              <div>Full Name: {{ item.firstname }} {{ item.lastname }}</div>
              <div>Salary: {{ item.Salary }}</div>
              <div>Status: {{ item.status }}</div>
              <div>Working Hour: 8</div>
            </v-card-text>
            <v-card-actions>
              <v-btn color="blue-darken-1" variant="text" @click="item.dialog1 = false">
                Close
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize">
          Reset
        </v-btn>
      </template>
    </v-data-table>
  </div>
</template>


